// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
// -------------------------------------------------------------
unit render;

interface

uses OpenGL,vector,mesh, exgine;

procedure DrawPoints(points:TVectors);
procedure DrawPolysWire(mesh:TMesh);
procedure DrawNormals(mesh:TMesh);
procedure DrawPolys(mesh:TMesh);

implementation

procedure DrawPoints(points:TVectors);
var i:integer;
begin
 glBegin(GL_POINTS);
 for i:=0 to length(points)-1 do
  begin
   glVertex3f(points[i].x,
              points[i].y,
              points[i].z)
  end;
 glEnd;
end;

procedure DrawPolysWire(mesh:TMesh);
var i:integer;
begin
for i:=0 to length(mesh.polygons)-1 do
 begin
  glBegin(GL_LINE_STRIP);
  glVertex3f(mesh.verts[mesh.polygons[i].vertIndex[0]].x,
             mesh.verts[mesh.polygons[i].vertIndex[0]].y,
             mesh.verts[mesh.polygons[i].vertIndex[0]].z);
  glVertex3f(mesh.verts[mesh.polygons[i].vertIndex[1]].x,
             mesh.verts[mesh.polygons[i].vertIndex[1]].y,
             mesh.verts[mesh.polygons[i].vertIndex[1]].z);
  glVertex3f(mesh.verts[mesh.polygons[i].vertIndex[2]].x,
             mesh.verts[mesh.polygons[i].vertIndex[2]].y,
             mesh.verts[mesh.polygons[i].vertIndex[2]].z);

  glEnd;
 end;

end;

procedure DrawNormals(mesh:TMesh);
var i,j:integer;
begin
for i:=0 to length(mesh.polygons)-1 do
 begin
  glBegin(GL_LINES);

  for j:=0 to 2 do
    with mesh.verts[mesh.polygons[i].vertIndex[j]] do
     begin
      glVertex3f(x,y,z);
      glVertex3f(x+mesh.polygons[i].normal[j].x/10,
                 y+mesh.polygons[i].normal[j].y/10,
                 z+mesh.polygons[i].normal[j].z/10)

     end;

  glEnd;
 end;

end;


procedure DrawPolys(mesh:TMesh);
var i,j:integer;
    curtex:longword;
begin
curtex:=0;

for i:=0 to length(mesh.polygons)-1 do
 begin

 (*
  if mesh.polygons[i].textureId<>curtex then
   begin
    tex.Enable(mesh.polygons[i].textureId,0);
    curtex:=mesh.polygons[i].textureId;
   end;
  *)

  
   tex.Enable(mesh.polygons[i].textureId,0);

   glBegin(GL_TRIANGLES);

   for j:=0 to 2 do
     begin
      glTexCoord2f(mesh.polygons[i].texcoord[j].x,
                   1-mesh.polygons[i].texcoord[j].y);
      glVertex3f(mesh.verts[mesh.polygons[i].vertIndex[j]].x,
                 mesh.verts[mesh.polygons[i].vertIndex[j]].y,
                 mesh.verts[mesh.polygons[i].vertIndex[j]].z);

     end;

   glEnd;


 end;

end;

end.
