// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
// -------------------------------------------------------------
unit skeleton;

interface

uses vector;

type TBonePos=record
               trans : TVector;
               rot   : TVector;
              end;

type TSkeletonNode=record
                    name       : string;
                    parent     : integer;
                   end;

type TSkeleton=array of TSkeletonNode;

type TAnimFrame=array of TBonePos;

type TAnimFrames=array of TAnimFrame;

type TAction=record
              name       : string;
              fps        : single;
              animFrames : TAnimFrames;
             end;

type TActions=array of TAction;

type TSkeletonState=record
                     prevFrame:integer;
                     nextFrame:integer;
                     prevAction:integer;
                     nextAction:integer;
                     interpTime:single;
                     currentPose: TAnimFrame;
                    end;

type TBoneWeight=record
                  bone   : integer;
                  name   : string;
                  weight : single;
                 end;

type TVertParents=array of TBoneWeight;

type TVertsParents=array of TVertParents;


type TSkeletonAnimation=record
                         skeleton : TSkeleton;
                         actions  : TActions;
                         skeletonState : TSkeletonState;
                         vertsParents : TVertsParents;
                         reference  : TAnimFrame;
                        end;


implementation

end.
